"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var fs = _interopRequireWildcard(require("fs"));

var path = _interopRequireWildcard(require("path"));

var _rawLoader = _interopRequireDefault(require("./rawLoader"));

var _schemaLoader = _interopRequireDefault(require("./schemaLoader"));

var requireResolve = require('require-resolve');

var BabelInlineImportHelper =
/*#__PURE__*/
function () {
  function BabelInlineImportHelper() {
    (0, _classCallCheck2.default)(this, BabelInlineImportHelper);
  }

  (0, _createClass2.default)(BabelInlineImportHelper, null, [{
    key: "shouldBeInlined",
    // ['.a', '.b', '.c', { name: '.d', loader: (content) => `~~${content}~~` }]
    value: function shouldBeInlined(givenPath, extensions) {
      var accept = typeof extensions === 'string' ? [extensions] : extensions || BabelInlineImportHelper.extensions;
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = accept[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var extension = _step.value;
          var ext = extension.name || extension;

          if (givenPath.endsWith(ext)) {
            return true;
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return != null) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      return false;
    } // [ '', '', '' ]

  }, {
    key: "getLoader",
    value: function getLoader(givenPath, extensions) {
      var curr = extensions.find(function (extension) {
        var ext = extension.name || extension;
        return givenPath.endsWith(ext);
      }) || {};
      return curr.loader || _rawLoader.default;
    }
  }, {
    key: "getContents",
    value: function getContents(givenPath, reference, extensions) {
      if (!reference) {
        throw new Error('"reference" argument must be specified');
      }

      var mod = requireResolve(givenPath, path.resolve(reference));

      if (!mod || !mod.src) {
        throw new Error("Path '".concat(givenPath, "' could not be found for '").concat(reference, "'"));
      }

      var rawContent = fs.readFileSync(mod.src).toString();
      var loader = BabelInlineImportHelper.getLoader(givenPath, extensions || BabelInlineImportHelper.extensions);
      var content = loader(rawContent);
      return content;
    }
  }, {
    key: "transformRelativeToRootPath",
    value: function transformRelativeToRootPath(path, rootPathSuffix) {
      if (this.hasRoot(path)) {
        var withoutRoot = path.substring(1, path.length);
        return "".concat(BabelInlineImportHelper.root).concat(rootPathSuffix || '', "/").concat(withoutRoot);
      }

      if (typeof path === 'string') {
        return path;
      }

      throw new Error('ERROR: No path passed');
    }
  }, {
    key: "hasRoot",
    value: function hasRoot(string) {
      if (typeof string !== 'string') {
        return false;
      }

      return string.substring(0, 1) === '/';
    }
  }]);
  return BabelInlineImportHelper;
}();

exports.default = BabelInlineImportHelper;
(0, _defineProperty2.default)(BabelInlineImportHelper, "extensions", ['.raw', '.text', '.graphql', {
  name: '.schema',
  loader: _schemaLoader.default
}]);
(0, _defineProperty2.default)(BabelInlineImportHelper, "root", global.rootPath || process.cwd());